#include <cstdio>
#include <map>
#include <vector>
using namespace std;

int main (void)
{
  vector<unsigned> a;
  /* Je-li v aktuln mnoin souet x+y=z, pak do soucty[z] ulome x nebo y.  */
  map<unsigned, unsigned> soucty;
  unsigned i, j, n, x, y;

  /* Nateme zadn.  */
  scanf ("%u %u", &x, &n);
  for (i = 0; i < n; i++)
    {
      scanf ("%u", &y);
      a.push_back (y);
    }

  for (i = 0; i < n; i++)
    {
      /* Je-li X rovno jednomu ze vstupnch sel, prost ho vypeme.  */
      if (a[i] == x)
	{
	  printf ("%u\n", x);
	  return 0;
	}

      if (a[i] > x)
	continue;

      /* Je-li X rovno soutu a[i] a dalch dvou sel, vypeme tato ti sla.  */
      if (soucty.count (x - a[i]) > 0)
	{
	  unsigned b = soucty[x - a[i]];

	  printf ("%u %u %u\n", x - b - a[i], b, a[i]);
	  return 0;
	}

      /* Ovme, zda X je rovno soutu a[i], a[j] a dalch dvou sel.  */
      for (j = i + 1; j < n; j++)
	{
	  if (a[i] + a[j] > x)
	    continue;

	  if (soucty.count (x - a[i] - a[j]) > 0)
	    {
	      unsigned b = soucty[x - a[i] - a[j]];

	      printf ("%u %u %u %u\n", x - b - a[i] - a[j], b, a[i], a[j]);
	      return 0;
	    }
	}

      /* Upravme mnoinu soucty pidnm sout dvojic obsahujcch a[i].  */
      for (j = 0; j < i; j++)
	{
	  unsigned s = a[j] + a[i];

	  if (s > x)
	    continue;
	  /* Ovme, zda x je rovno soutu dvou sel.  */
	  if (s == x)
	    {
	      printf ("%u %u\n", a[j], a[i]);
	      return 0;
	    }

	  soucty[s] = a[i];
	}
    }

  printf ("Konec sveta se odklada\n");
  return 0;
}
